#include "Book.h"
#include <algorithm>
#include <string>
#include <list>

using namespace std;

Book::SortType Book::sortMethod = ISBN;

Book::~Book()
{
}

bool Book::operator!=(const Book& rhs) const
{
  return !(*this == rhs);
}

bool Book::operator<=(const Book& rhs) const
{
  return (*this < rhs || *this == rhs);
}

bool Book::operator>=(const Book& rhs) const
{
  return !(*this < rhs);
}

double Book::getPrice() const
{
  return price;
}

void Book::setPrice(double prc)
{
  price = prc;
}

//Jorge and Alex
Book& Book::operator=(const Book &rhs)
{
      title = rhs.title;
      authors = rhs.authors;
      isbn = rhs.isbn;
      year = rhs.year;
      publisher = rhs.publisher;
      price = rhs.price;
	  sortMethod = rhs.sortMethod;
	  return *this;
}

//Jorge and Alex
bool Book::operator >(const Book &rhs) const
{
      bool flag = false;
      if(!((*this)< rhs) && *this==rhs)
      {
            flag = true;
      }
      return flag;
}

//Jorge and Alex
string Book::getPublisher() const
{
      return publisher;
}

//Jorge and Alex
void Book::setPublisher(const string& pub)
{
      publisher = pub;
}

//Rolando Leal, Mike Gentili, Jon Dunder
Book::Book()
{
	isbn = 0;
	year = 0;
	price = 0;
}

//Rolando Leal, Mike Gentili, Jon Dunder
bool Book::operator==(const Book& rhs) const{
  bool works = false;
  if(title == rhs.title && authors == rhs.authors && isbn == rhs.isbn && year == rhs.year && publisher == rhs.publisher && price == rhs.price)
    works = true;
  return (works);
}

//Rolando Leal, Mike Gentili, Jon Dunder
void Book::setTitle(const std::string& temptitle) {
	title = temptitle;
}

//Rolando Leal, Mike Gentili, Jon Dunder
std::string Book::getTitle() const {
	return title;
}

// AUTHORS: yusuf abbasi,Zbynek Srubar, Karol Schober
Book::Book (const Book& org ): title(org.title), authors(org.authors), isbn(org.isbn), year(org.year), publisher(org.publisher),
price(org.price) {

}

// AUTHORS: yusuf abbasi,Zbynek Srubar, Karol Schober
list <string> Book::getAuthors()const{ 
 return authors;
}


// AUTHORS: yusuf abbasi,Zbynek Srubar, Karol Schober
void Book::setAuthors(const list<string> &  book_designers){
	authors=book_designers;
	authors.sort();
}


// AUTHORS: yusuf abbasi,Zbynek Srubar, Karol Schober
bool Book::operator< (const Book & rhs) const {
	bool temp;
	switch (sortMethod ) {
	case	TITLE:   temp = title<rhs.title;
			   break;

	case	ISBN:  temp = isbn<rhs.isbn;
			   break;
		
	case PUBLISHER: temp = publisher<rhs.publisher;
			   break;

	case	YEAR:  temp= year<rhs.year;
			   break;

	case	PRICE: temp= price<rhs.price;
			   break;
	   	
	case AUTHORS:   temp= authors<rhs.authors;
			   break;
	}
	return temp;
}

void Book::setYear(const unsigned int rhs)
{
	year = rhs;
}

unsigned int Book::getYear() const
{
	return year;
}

void Book::setISBN(const long unsigned int i)
{
      isbn = i;
}

long unsigned int Book::getISBN() const
{
      return isbn;
}

void Book::setSortMethod(SortType type)
{
	sortMethod = type;
}
